// (C) Copyright 2003: Reece H. Dunn

#ifndef BOOST__IOFM__DETAIL__CONFIG__HPP
#define BOOST__IOFM__DETAIL__CONFIG__HPP
#  include <boost/config.hpp>

   // custom configuration to identify supported boost libraries and
   // I/O formatting technologies available

#  if defined(BOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
#     define BOOST_IOFM__NO_OUTPUT_DEDUCTION 
#  endif

#  if defined(__BORLANDC__)
      // C++Compiler 5.5 - quaternion/octonion:
      //    does not like BOOST_QUATERNION_OPERATOR_GENERATOR(/)

#     define BOOST_IOFM__NO_LIB_QUATERNION
#     define BOOST_IOFM__NO_LIB_OCTONION

      // Borland compiler:
      //    compiles detail/type_deduction without a problem
      //    detail/type_deduction: compiles, but complains on:
      //       typedef typename boost::io::deducer< T >::type deduced_output;
      //       typedef typenamededuced_output::outputter      foo_bar;
      //       >>> I do not know any workarounds at present, so:
      
#     define BOOST_IOFM__NO_OUTPUT_DEDUCTION
#  elif defined(__GNUC__)
#     define BOOST_IOFM__NO_STD_WSTREAM

      // GNU 2.95.3-5 - quaternion/octonion: cannot find limits standard header file
      // GNU 3.3      - quaternion/octonion: many errors like
      //    boost/1.30.0/boost/math/quaternion.hpp:449:
      //       error: `R_component_2' undeclared (first use this function)

#     if(__GNUC__ == 2 )
#        define BOOST_IOFM__NO_LIB_QUATERNION
#        define BOOST_IOFM__NO_LIB_OCTONION
#        define BOOST_IOFM__NO_LIB_INTERVAL // 'static_cast_expr' not supported by dump_expr
#     endif
#  endif
#endif
